/*

                         \\\|///
                       \\  - -  //
                        (  @ @  )
+---------------------oOOo-(_)-oOOo-------------------------+
|                       Z111x Demo                          |
|                                                           |
|                 ЦȻ by Xiaoran Liu                     |
|                        2010.3.26                          |
| ========================================================= |
|        ֲؼо ZERO Research Institute         |
|                      www.the0.net                         |
|                             Oooo                          |
+-----------------------oooO--(   )-------------------------+
                       (   )   ) /
                        \ (   (_/
                         \_)     

*/
/*----------------------------------------------------------*\
 |  оƬͷļ                                    |
\*----------------------------------------------------------*/
#include "LPC11xx.h"		/* LPC11xx Peripheral Registers */

//extern uint32_t SystemAHBFrequency;
/*----------------------------------------------------------*\
 | HARDWARE DEFINE                                          |
\*----------------------------------------------------------*/
#define LED       (1<<5)      /* LED D1 connect to PIO3_5 */

#define LSR_RDR		0x01
#define LSR_OE		0x02
#define LSR_PE		0x04
#define LSR_FE		0x08
#define LSR_BI		0x10
#define LSR_THRE	0x20
#define LSR_TEMT	0x40
#define LSR_RXFE	0x80
/*----------------------------------------------------------*\
 |  Delay  ʱ Inserts a delay time.                       |
 |  nCount: ʱʱ specifies the delay time length.       |
\*----------------------------------------------------------*/
void Delay(unsigned nCount) {
  for(; nCount != 0; nCount--);
  }
/*----------------------------------------------------------*\
 | UART_Init                                                |
\*----------------------------------------------------------*/
void UART_Init(uint32_t baudrate)
{
  uint32_t Fdiv;
  uint32_t regVal;

  NVIC_DisableIRQ(UART_IRQn);

  LPC_IOCON->PIO1_6 &= ~0x07;    /*  UART I/O config */
  LPC_IOCON->PIO1_6 |= 0x01;     /* UART RXD */
  LPC_IOCON->PIO1_7 &= ~0x07;	
  LPC_IOCON->PIO1_7 |= 0x01;     /* UART TXD */

  /* Enable UART clock */
  LPC_SYSCON->SYSAHBCLKCTRL |= (1<<12);
  LPC_SYSCON->UARTCLKDIV = 0x1;     /* divided by 1 */

  LPC_UART->LCR = 0x83;             /* 8 bits, no Parity, 1 Stop bit */
  regVal = LPC_SYSCON->UARTCLKDIV;
  Fdiv = ((SystemAHBFrequency/regVal)/16)/baudrate ;	/*baud rate */

  LPC_UART->DLM = Fdiv / 256;							
  LPC_UART->DLL = Fdiv % 256;
  LPC_UART->LCR = 0x03;		/* DLAB = 0 */
  LPC_UART->FCR = 0x07;		/* Enable and reset TX and RX FIFO. */

  /* Read to clear the line status. */
  regVal = LPC_UART->LSR;

  /* Ensure a clean start, no data in either TX or RX FIFO. */
  while ( LPC_UART->LSR & (LSR_THRE|LSR_TEMT) != (LSR_THRE|LSR_TEMT) );
  while ( LPC_UART->LSR & LSR_RDR ) {
  	regVal = LPC_UART->RBR;	/* Dump data from RX FIFO */
    }
  }
/*----------------------------------------------------------*\
 | UART_GetChar                                             |
\*----------------------------------------------------------*/
int UART_GetChar( void ) {
  while( !(LPC_UART->LSR & 0x01));
  return (LPC_UART->RBR);
  }
/*----------------------------------------------------------*\
 | UART_GetChar                                             |
\*----------------------------------------------------------*/
int UART_PutChar( int ch ) {
  while( !(LPC_UART->LSR & 0x20));
  return (LPC_UART->THR = ch);
  }
/*----------------------------------------------------------*\
 | MIAN ENTRY                                               |
\*----------------------------------------------------------*/
int main() {
  SystemInit();
  /* Enable AHB clock to the GPIO domain. */
  LPC_SYSCON->SYSAHBCLKCTRL |= (1<<6);
  LPC_GPIO3->DIR |= LED;      // pin output

  UART_Init( 9600 );

  for(;;) {
    LPC_GPIO3->DATA ^= LED;  // reset pin : LED light
    UART_PutChar( UART_GetChar() );
    }
  }
/*---------------------  END OF FILE  ----------------------*\
 |                        COPYRIGHT                         |
 |        ֲؼо ZERO Research Institute        |
 |                      www.the0.net                        |
\*----------------------------------------------------------*/
